Unit IS02R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTIS10_p;

procedure IS02R(N :Integer; var X :Array of Real;
                var U :Array of Real; var P :Array of Real;
                var Y :Array of Real; var Y2 :Array of Real;
                var DX :Array of Real; var E :Array of Real;
                var R :Array of Real; var IERR :Integer);

implementation

procedure IS02R(N :Integer; var X :Array of Real;
                var U :Array of Real; var P :Array of Real;
                var Y :Array of Real; var Y2 :Array of Real;
                var DX :Array of Real; var E :Array of Real;
                var R :Array of Real; var IERR :Integer);
var
N1,N2,J1,J2,K :Integer;
E0,H1,H2,H3,H4,H5,HH,R1,R2,UP,VP,WP,W,W1,WW,WW1,WW2 :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25;
begin
IERR := 0;
if ( N < 3 ) 
 then goto _21;
N1 := N-1;
for K:=1 to N1 do
 begin
  E0 := X[K+0]-X[K-1];
  if ( E0 <= 0.0 ) 
   then goto _22;
  if ( P[K-1] <= 0.0 ) 
   then goto _23;
_1:
 end;
N2 := N-2;
WW := 1.0;
WW1 := 0.0;
R[1] := 0.0;
R[2] := -1.0;
J1 := 1;
H1 := X[N-1]-X[N1-1];
for K:=1 to N1 do
 begin
  J2 := K+1;
  H2 := X[J2-1]-X[K-1];
  DX[K-1] := H2;
  R[3+(K-1)*6] := 1.0/(2.0*(H1+H2)-H1*R[1+(J1-1)*6]);
  R[1+(K-1)*6] := R[3+(K-1)*6]*H2;
  R[2+(K-1)*6] := -R[3+(K-1)*6]*R[2+(J1-1)*6]*H1;
  J1 := K;
  H1 := H2;
_2:
 end;
_3:
for K:=1 to N do
 begin
  Y2[K-1] := 0.0;
  Y[K-1] := U[K-1];
_4:
 end;
_5:
W := WW;
W1 := 1.0-W;
Y[N-1] := Y[0];
J1 := 1;
R[0] := 0.0;
H1 := DX[N1-1];
WP := H1;
H2 := DX[N2-1];
UP := 2.0*(H1+H2);
R1 := (Y[N-1]-Y[N1-1])/H1;
R2 := (Y[N1-1]-Y[N2-1])/H2;
VP := 6.0*(R1-R2);
for K:=1 to N1 do
 begin
  J2 := K+1;
  H2 := DX[K-1];
  R2 := (Y[J2-1]-Y[K-1])/H2;
  if ( K = 1 ) 
   then goto _6;
  UP := UP-WP*R[2+(J1-1)*6];
  VP := VP-WP*R[0+(J1-1)*6];
  WP := -R[1+(J1-1)*6]*WP;
_6:
  R[0+(K-1)*6] := R[3+(K-1)*6]*(6.0*(R2-R1)-H1*R[0+(J1-1)*6]);
  J1 := K;
  H1 := H2;
  R1 := R2;
_7:
 end;
H2 := WP+H1;
H1 := (VP-H2*R[0+(N1-1)*6])/(UP-H2*(R[1+(N1-1)*6]+R[2+(N1-1)*6]));
R[5+(N1-1)*6] := H1;
if ( N1 <= 2 ) 
 then goto _9;
for J1:=2 to N1 do
 begin
  K := N-J1;
  R[5+(K-1)*6] := R[0+(K-1)*6]-R[1+(K-1)*6]*R[5+(K+1-1)*6]-R[2+(K-1)*6]*H1;
_8:
 end;
_9:
for K:=1 to N1 do
 begin
  R[5+(K-1)*6] := W*R[5+(K-1)*6]+W1*Y2[K-1];
_10:
 end;
R[5+(N-1)*6] := R[5];
J1 := N1;
H5 := 0.0;
for K:=1 to N1 do
 begin
  J2 := K+1;
  if ( K = N1 ) 
   then J2 := 1;
  HH := ((R[5+(J2-1)*6]-R[5+(K-1)*6])/DX[K-1]-(R[5+(K-1)*6]-R[5+(J1-1)*6])/DX[J1-1])/
    P[K-1];
  if ( W = 1.0 ) 
   then R[4+(K-1)*6] := -HH;
  if ( W <> 1.0 ) 
   then R[4+(K-1)*6] := W*(U[K-1]-HH)+W1*Y[K-1];
  H5 := H5+Abs(R[4+(K-1)*6]);
  J1 := K;
_11:
 end;
H5 := 1.0/H5;
if ( W <> 1.0 ) 
 then goto _14;
H1 := 0.0;
H2 := 0.0;
for K:=1 to N1 do
 begin
  HH := Y[K-1];
  H1 := H1+R[4+(K-1)*6]*HH;
  H2 := H2+HH*HH;
_12:
 end;
WW2 := H1/H2;
if ( Abs(WW2-WW1) < 5.E-4*Abs(WW2) ) 
 then goto _13;
WW1 := WW2;
goto _16;
_13:
WW := 2.0/(1.0+Sqrt(1.0-WW2));
goto _3;
_14:
H2 := 0.0;
H3 := 0.0;
H4 := 0.0;
for K:=1 to N1 do
 begin
  H2 := H2+Abs(R[4+(K-1)*6]-Y[K-1]);
  H3 := H3+Abs(R[5+(K-1)*6]);
  H4 := H4+Abs(R[5+(K-1)*6]-Y2[K-1]);
_15:
 end;
if ( H2*H5+H4/H3 < 5.E-4 ) 
 then goto _18;
H5 := 1.0;
_16:
for K:=1 to N do
 begin
  Y2[K-1] := R[5+(K-1)*6];
  Y[K-1] := R[4+(K-1)*6]*H5;
_17:
 end;
goto _5;
_18:
for K:=1 to N1 do
 begin
  Y[K-1] := R[4+(K-1)*6];
  Y2[K-1] := R[5+(K-1)*6];
_19:
 end;
Y2[N-1] := Y2[0];
Y[N-1] := Y[0];
P[N-1] := P[0];
E[0] := 0.0;
E[1] := P[N-1]*IntPower(Y[N-1]-U[N-1],2);
E0 := P[N-1];
for K:=1 to N1 do
 begin
  E[0] := E[0]+DX[K-1]*(IntPower(Y2[K+0],2)+Y2[K+0]*Y2[K-1]+IntPower(Y2[K-1],2));
  E[1] := E[1]+P[K-1]*IntPower(Y[K-1]-U[K-1],2);
  E0 := E0+P[K-1];
_20:
 end;
E[0] := E[0]/3.0;
E[1] := E[1]/E0;
goto _25;
_21:
IERR := 65;
goto _24;
_22:
IERR := 66;
goto _24;
_23:
IERR := 67;
_24:
UTIS10(IERR,8);
_25:
end;

end.
